org.springside.components.ajaxupload
类 AjaxMultipartRequestHandler

java.lang.Object
  继承者 org.springside.components.ajaxupload.AjaxMultipartRequestHandler

public class AjaxMultipartRequestHandler
extends java.lang.Object

This class implements the MultipartRequestHandler interface by providing a wrapper around the Jakarta Commons FileUpload library.

自从:
Struts 1.1

字段摘要
static long DEFAULT_SIZE_MAX
          The default value for the maximum allowable size, in bytes, of an uploaded file.
static int DEFAULT_SIZE_THRESHOLD
          The default value for the threshold which determines whether an uploaded file will be written to disk or cached in memory.
protected static Log log
          Commons Logging instance.
 
构造函数摘要
AjaxMultipartRequestHandler()
           
 
方法摘要
protected  void addFileParameter(FileItem item)
          Adds a file parameter to the set of file parameters for this request and also to the list of all parameters.
protected  void addTextParameter(HttpServletRequest request, FileItem item)
          Adds a regular text parameter to the set of text parameters for this request and also to the list of all parameters.
protected  long convertSizeToBytes(java.lang.String sizeString, long defaultSize)
          Converts a size value from a string representation to its numeric value.
 void finish()
          Cleans up at the end of a request.
 java.util.Hashtable getAllElements()
          Returns a hash table containing both text and file request parameters.
 java.util.Hashtable getFileElements()
          Returns a hash table containing the file (that is, non-text) request parameters.
 ActionMapping getMapping()
          Retrieves the action mapping with which this handler is associated.
protected  java.lang.String getRepositoryPath(ModuleConfig mc)
          Returns the path to the temporary directory to be used for uploaded files which are written to disk.
 ActionServlet getServlet()
          Retrieves the servlet with which this handler is associated.
protected  long getSizeMax(ModuleConfig mc)
          Returns the maximum allowable size, in bytes, of an uploaded file.
protected  long getSizeThreshold(ModuleConfig mc)
          Returns the size threshold which determines whether an uploaded file will be written to disk or cached in memory.
 java.util.Hashtable getTextElements()
          Returns a hash table containing the text (that is, non-file) request parameters.
 void handleRequest(HttpServletRequest request)
          Parses the input stream and partitions the parsed items into a set of form fields and a set of file items.
 void rollback()
          Cleans up when a problem occurs during request processing.
 void setMapping(ActionMapping mapping)
          Sets the action mapping with which this handler is associated.
 void setServlet(ActionServlet servlet)
          Sets the servlet with which this handler is associated.
 
从类 java.lang.Object 继承的方法
clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait
 

字段详细信息

DEFAULT_SIZE_MAX

public static final long DEFAULT_SIZE_MAX
The default value for the maximum allowable size, in bytes, of an uploaded file. The value is equivalent to 250MB.

另请参见:
常量字段值

DEFAULT_SIZE_THRESHOLD

public static final int DEFAULT_SIZE_THRESHOLD
The default value for the threshold which determines whether an uploaded file will be written to disk or cached in memory. The value is equivalent to 250KB.

另请参见:
常量字段值

log

protected static final Log log
Commons Logging instance.

构造函数详细信息

AjaxMultipartRequestHandler

public AjaxMultipartRequestHandler()
方法详细信息

getServlet

public ActionServlet getServlet()
Retrieves the servlet with which this handler is associated.

返回:
The associated servlet.

setServlet

public void setServlet(ActionServlet servlet)
Sets the servlet with which this handler is associated.

参数:
servlet - The associated servlet.

getMapping

public ActionMapping getMapping()
Retrieves the action mapping with which this handler is associated.

返回:
The associated action mapping.

setMapping

public void setMapping(ActionMapping mapping)
Sets the action mapping with which this handler is associated.

参数:
mapping - The associated action mapping.

handleRequest

public void handleRequest(HttpServletRequest request)
                   throws ServletException
Parses the input stream and partitions the parsed items into a set of form fields and a set of file items. In the process, the parsed items are translated from Commons FileUpload FileItem instances to Struts FormFile instances.

参数:
request - The multipart request to be processed.
抛出:
ServletException - if an unrecoverable error occurs.

getTextElements

public java.util.Hashtable getTextElements()
Returns a hash table containing the text (that is, non-file) request parameters.

返回:
The text request parameters.

getFileElements

public java.util.Hashtable getFileElements()
Returns a hash table containing the file (that is, non-text) request parameters.

返回:
The file request parameters.

getAllElements

public java.util.Hashtable getAllElements()
Returns a hash table containing both text and file request parameters.

返回:
The text and file request parameters.

rollback

public void rollback()
Cleans up when a problem occurs during request processing.


finish

public void finish()
Cleans up at the end of a request.


getSizeMax

protected long getSizeMax(ModuleConfig mc)
Returns the maximum allowable size, in bytes, of an uploaded file. The value is obtained from the current module's controller configuration.

参数:
mc - The current module's configuration.
返回:
The maximum allowable file size, in bytes.

getSizeThreshold

protected long getSizeThreshold(ModuleConfig mc)
Returns the size threshold which determines whether an uploaded file will be written to disk or cached in memory.

参数:
mc - The current module's configuration.
返回:
The size threshold, in bytes.

convertSizeToBytes

protected long convertSizeToBytes(java.lang.String sizeString,
                                  long defaultSize)
Converts a size value from a string representation to its numeric value. The string must be of the form nnnm, where nnn is an arbitrary decimal value, and m is a multiplier. The multiplier must be one of 'K', 'M' and 'G', representing kilobytes, megabytes and gigabytes respectively.

If the size value cannot be converted, for example due to invalid syntax, the supplied default is returned instead.

参数:
sizeString - The string representation of the size to be converted.
defaultSize - The value to be returned if the string is invalid.
返回:
The actual size in bytes.

getRepositoryPath

protected java.lang.String getRepositoryPath(ModuleConfig mc)
Returns the path to the temporary directory to be used for uploaded files which are written to disk. The directory used is determined from the first of the following to be non-empty.
  1. A temp dir explicitly defined either using the tempDir servlet init param, or the tempDir attribute of the <controller> element in the Struts config file.
  2. The container-specified temp dir, obtained from the javax.servlet.context.tempdir servlet context attribute.
  3. The temp dir specified by the java.io.tmpdir system property.
  4. (/ol>

    参数:
    mc - The module config instance for which the path should be determined.
    返回:
    The path to the directory to be used to store uploaded files.

addTextParameter

protected void addTextParameter(HttpServletRequest request,
                                FileItem item)
Adds a regular text parameter to the set of text parameters for this request and also to the list of all parameters. Handles the case of multiple values for the same parameter by using an array for the parameter value.

参数:
request - The request in which the parameter was specified.
item - The file item for the parameter to add.

addFileParameter

protected void addFileParameter(FileItem item)
Adds a file parameter to the set of file parameters for this request and also to the list of all parameters.

参数:
item - The file item for the parameter to add.